<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla controller library
jimport('joomla.application.component.controller');
jimport( 'joomla.application.input.files' );
 
/**
 * OpenERP Component Controller
 */
class OerpControllerPostPDF extends JControllerLegacy
{
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param       type    The table type to instantiate
	 * @param       string  A prefix for the table class name. Optional.
	 * @param       array   Configuration array for model. Optional.
	 * @return      JTable  A database object
	 * @since       2.5
	 */
	public function getTable($type = 'Openerp', $prefix = 'OpenerpTable', $config = array()) 
	{
			JTable::addIncludePath($this->basePath."/tables");		
			return JTable::getInstance($type, $prefix, $config);
	}
	
	public function execute()
	{
		JSession::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));

		// request the selected id
		$oerp_id = JRequest::getInt('oerp_id');
		
		// Get a TableOpenerp instance
		$table = $this->getTable();
		
		// Load the connection data
		$table->load($oerp_id);
		
		// ... define $HOST, $PORT, $DB, $USER, $PASS
		$HOST = $table->host;
		$PORT = $table->port;
		$DB = $table->db;
		$USER = $table->user;
		$PASS = $table->password;

		// Get some data from the request
		$doc_id = $this->input->getInt('doc_id');
		$file = JRequest::getVar('Filedata', '', 'files', 'array');
		$return       = $this->input->post->get('return-url', null, 'base64');
		$user		= JFactory::getUser();
		$partnerVat = $user->username;
		
		// Set the redirect
		if ($return)
		{
			$this->setRedirect(base64_decode($return));
		}

		try {
			// Cargamos el archivo
			set_include_path($this->basePath."/libraries");

			include('get_openerp_uid.inc');
			
			// Search documents
			$client = new xmlrpc_client("http://$HOST:$PORT/xmlrpc/object");
			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('signer', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('id', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($doc_id, "int") ,
				), "array"),
			);
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("search", "string"));
			$msg->addParam(new xmlrpcval($arrayList, "array"));
			$resp = $client->send($msg);
			$ids = $resp->value();
			
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("write", "string"));
			$msg->addParam($ids);
			$msg->addParam(
				php_xmlrpc_encode(
					array(
						'datas'=>base64_encode(
							file_get_contents($file['tmp_name'])
							),
						'datas_fname'=>$file['name'],
						)
				)
			);
			$resp = $client->send($msg);
			$result = php_xmlrpc_decode($resp->value());
			JFactory::getApplication()->enqueueMessage(JText::_('COM_OERP_FILE_UPLOADED'),'success');
		}catch(Exception $exception){
			echo "<pre>".$exception."</pre>";
		}
	}
}

