<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla controller library
jimport('joomla.application.component.controller');

/**
 * OpenERP Component Controller
 */
class OerpControllerReceivePDFSigned extends JControllerLegacy
{
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param       type    The table type to instantiate
	 * @param       string  A prefix for the table class name. Optional.
	 * @param       array   Configuration array for model. Optional.
	 * @return      JTable  A database object
	 * @since       2.5
	 */
	public function getTable($type = 'Openerp', $prefix = 'OpenerpTable', $config = array()) 
	{
			JTable::addIncludePath($this->basePath."/tables");		
			return JTable::getInstance($type, $prefix, $config);
	}
	
	public function execute()
	{
		$doc_id = $this->input->getInt('doc_id');
		$user		= JFactory::getUser();
		$partnerVat = $user->username;

		// request the selected id
		$oerp_id = JRequest::getInt('oerp_id');
		$return = JRequest::getInt('return');
		$cancel = JRequest::getString('cancel');

		// Set the redirect
		if ($return)
		{
			$this->setRedirect(base64_decode($return));
		}
		
		if ($cancel=='signcanceled') {
			JFactory::getApplication()->enqueueMessage(JText::_('COM_OERP_USER_CANCEL_SIGN'));
		} else {
				
			// Get a TableOpenerp instance
			$table = $this->getTable();
			
			// Load the connection data
			$table->load($oerp_id);
			
			// ... define $HOST, $PORT, $DB, $USER, $PASS
			$HOST = $table->host;
			$PORT = $table->port;
			$DB = $table->db;
			$USER = $table->user;
			$PASS = $table->password;

			try {
				set_include_path($this->basePath."/libraries");
				include_once("viafirma/includes.php");

				$viafirmaClient = ViafirmaClientFactory::getInstance();
				$usuarioGenerico = $viafirmaClient->recuperarRespuestaOpenId();
			
				if(!$usuarioGenerico){
					JFactory::getApplication()->enqueueMessage(JText::_('COM_OERP_NO_VIAFIRMA_USER'),'error');
				}else{
					if ($usuarioGenerico->signId!="") {
						$documentoFirmado=$viafirmaClient->getDocumentoCustodiado($usuarioGenerico->signId);

						include('get_openerp_uid.inc');
						// saving into OpenERP

						// Search documents
						$client = new xmlrpc_client("http://$HOST:$PORT/xmlrpc/object");
						$arrayList = array(
							new xmlrpcval(array(
								new xmlrpcval('partner_id.vat', "string"),
								new xmlrpcval('=', "string"),
								new xmlrpcval('ES'.$partnerVat, "string") ,
							), "array"),
							new xmlrpcval(array(
								new xmlrpcval('id', "string"),
								new xmlrpcval('=', "string"),
								new xmlrpcval($doc_id, "int") ,
							), "array"),
						);
						$msg = new xmlrpcmsg('execute');
						$msg->addParam(new xmlrpcval($DB, "string"));
						$msg->addParam(new xmlrpcval($uid, "int"));
						$msg->addParam(new xmlrpcval($PASS, "string"));
						$msg->addParam(new xmlrpcval("ir.attachment", "string"));
						$msg->addParam(new xmlrpcval("search", "string"));
						$msg->addParam(new xmlrpcval($arrayList, "array"));
						$resp = $client->send($msg);
						$ids = $resp->value();
						
						$msg = new xmlrpcmsg('execute');
						$msg->addParam(new xmlrpcval($DB, "string"));
						$msg->addParam(new xmlrpcval($uid, "int"));
						$msg->addParam(new xmlrpcval($PASS, "string"));
						$msg->addParam(new xmlrpcval("ir.attachment", "string"));
						$msg->addParam(new xmlrpcval("write", "string"));
						$msg->addParam($ids);
						$msg->addParam(php_xmlrpc_encode(array('datas'=>base64_encode($documentoFirmado))));
						$resp = $client->send($msg);
						$result = php_xmlrpc_decode($resp->value());
						if ($result) {
							JFactory::getApplication()->enqueueMessage(JText::_('COM_OERP_PDF_SIGNED_RECEIVED'),'success');
						}
					}
				}
			}catch(Exception $exception){
				echo "<pre>".$exception."</pre>";
			}
		}
	}
}

