<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla controller library
jimport('joomla.application.component.controller');

/**
 * OpenERP Component Controller
 */
class OerpControllerReturnPDF extends JControllerLegacy
{
	
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param       type    The table type to instantiate
	 * @param       string  A prefix for the table class name. Optional.
	 * @param       array   Configuration array for model. Optional.
	 * @return      JTable  A database object
	 * @since       2.5
	 */
	public function getTable($type = 'Openerp', $prefix = 'OpenerpTable', $config = array()) 
	{
			JTable::addIncludePath($this->basePath."/tables");
			return JTable::getInstance($type, $prefix, $config);
	}
	
	public function execute()
	{

		JSession::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));

		$doc_id = $this->input->getInt('doc_id');
		$user		= JFactory::getUser();
		$partnerVat = $user->username;

		// request the selected id
		$oerp_id = JRequest::getInt('oerp_id');
		try {
		
			// Get a TableOpenerp instance
			$table = $this->getTable();
			if (! $table ) return;
			// Load the connection data
			$table->load($oerp_id);
			
			// ... define $HOST, $PORT, $DB, $USER, $PASS
			$HOST = $table->host;
			$PORT = $table->port;
			$DB = $table->db;
			$USER = $table->user;
			$PASS = $table->password;

			set_include_path($this->basePath."/libraries");
			// saving into OpenERP
			include('get_openerp_uid.inc');
			
			// Search documents
			$client = new xmlrpc_client("http://$HOST:$PORT/xmlrpc/object");
			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('signer', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('id', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($doc_id, "int") ,
				), "array"),
			);
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("search", "string"));
			$msg->addParam(new xmlrpcval($arrayList, "array"));
			$resp = $client->send($msg);
			$ids = $resp->value();
			
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("read", "string"));
			$msg->addParam($ids);
			$msg->addParam(php_xmlrpc_encode(array('datas','datas_fname')));
			$resp = $client->send($msg);
			$docs = php_xmlrpc_decode($resp->value());
			$doc = $docs[0];
			$datos = base64_decode($doc['datas']);
			
			header("Content-Disposition: attachment; filename=" . urlencode($doc['datas_fname']));   
			header("Content-Type: application/force-download");
			header("Content-Type: application/octet-stream");
			header("Content-Type: application/download");
			header("Content-Description: File Transfer");            
			header("Content-Length: " . strlen($datos));
			flush(); // this doesn't really matter.
			echo $datos;
			flush();
					
		}catch(Exception $exception){
			echo "<pre>".$exception."</pre>";
		}
	}
}

