<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla controller library
jimport('joomla.application.component.controller');
 
/**
 * OpenERP Component Controller
 */
class OerpControllerSignPDF extends JControllerLegacy
{
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param       type    The table type to instantiate
	 * @param       string  A prefix for the table class name. Optional.
	 * @param       array   Configuration array for model. Optional.
	 * @return      JTable  A database object
	 * @since       2.5
	 */
	public function getTable($type = 'Openerp', $prefix = 'OpenerpTable', $config = array()) 
	{
			JTable::addIncludePath($this->basePath."/tables");				
			return JTable::getInstance($type, $prefix, $config);
	}
	
	public function execute()
	{
		JSession::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));

		// Collect some data from request
		$oerp_id = JRequest::getInt('oerp_id');
		$doc_id = $this->input->getInt('doc_id');

		// Contruct the URL return into Joomla
		$return = base64_encode(JRoute::_('index.php?option=com_oerp&oerp_id='.$this->oerp_id));
		
		$user		= JFactory::getUser();
		$partnerVat = $user->username;

		// Get a TableOpenerp instance
		$table = $this->getTable();
		
		// Load the connection data
		$table->load($oerp_id);
		
		// ... define $HOST, $PORT, $DB, $USER, $PASS
		$HOST = $table->host;
		$PORT = $table->port;
		$DB = $table->db;
		$USER = $table->user;
		$PASS = $table->password;

		try {
			set_include_path($this->basePath."/libraries");
			include_once("viafirma/includes.php");
	        // URL en la que se encuentra el servicio de Viafirma y url pública de la aplicación 
			ViafirmaClientFactory::init($VIAFIRMA_SERVICE_URL, $VIAFIRMA_SERVICE_URL."/rest", $APPLICATION_URL);
			$viafirmaClient = ViafirmaClientFactory::getInstance();
			
			// Cargamos el archivo
			include('get_openerp_uid.inc');
			
			// Search documents
			$client = new xmlrpc_client("http://$HOST:$PORT/xmlrpc/object");
			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('partner_id.vat', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval('ES'.$partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('id', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($doc_id, "int") ,
				), "array"),
			);
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("search", "string"));
			$msg->addParam(new xmlrpcval($arrayList, "array"));
			$resp = $client->send($msg);
			$ids = $resp->value();
			
			$msg = new xmlrpcmsg('execute');
			$msg->addParam(new xmlrpcval($DB, "string"));
			$msg->addParam(new xmlrpcval($uid, "int"));
			$msg->addParam(new xmlrpcval($PASS, "string"));
			$msg->addParam(new xmlrpcval("ir.attachment", "string"));
			$msg->addParam(new xmlrpcval("read", "string"));
			$msg->addParam($ids);
			$msg->addParam(php_xmlrpc_encode(array('datas','name')));
			$resp = $client->send($msg);
			$docs = php_xmlrpc_decode($resp->value());
			$doc = $docs[0];
			$datos = base64_decode($doc['datas']);
			

			//Subimos el documento al servidor
			$idFirma=$viafirmaClient->prepareFirmaWithTypeFileAndFormatSign(
				$doc['name'],
				MimeType::$PDF,
				base64_decode($doc['datas']),
				SignatureType::$PDF_PKCS7	);
			
			//Iniciamos el proceso de firma
			//Url de retorno a la aplicación (tras el proceso de firma)
			$return_url = JUri::current().'?';
			foreach ($_REQUEST as $key=>$value) {
				if ($key == 'task') {
					$return_url .= 'task=ReceivePDFSigned.ReceivePDFSigned&';
				} else {
					$return_url .= $key.'='.$value.'&';
				}
			}
			$return_url = rtrim($return_url, '&');
			$return_url.= "&return=$return";
			$viafirmaClient->solicitarFirma($idFirma,$return_url);
			
		}catch(Exception $exception){
			echo "<pre>".$exception."</pre>";
		}
	}
}

