<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla modelitem library
jimport('joomla.application.component.modelitem');
 
/**
 * Oerp Model
 */
class OerpModelOerp extends JModelItem
{
	/**
	 * @var array documents to sign
	 */
	protected $docs_to_sign;

	/**
	 * @var array checked documents
	 */
	protected $checked_docs;

	/**
	 * @var array unverified documents
	 */
	protected $unverified_docs;

	/**
	 * @var array own documents
	 */
	protected $own_docs;

	/**
	 * @var int oerp_id
	 */
	protected $oerp_id;

	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param       type    The table type to instantiate
	 * @param       string  A prefix for the table class name. Optional.
	 * @param       array   Configuration array for model. Optional.
	 * @return      JTable  A database object
	 * @since       2.5
	 */
	public function getTable($type = 'Openerp', $prefix = 'OpenerpTable', $config = array()) 
	{
			return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Get the oerp_id
	 * @return integer oerp_id 
	 */
	public function getOerp_id() 
	{
		if (!isset($this->oerp_id)) {
			$this->oerp_id = JRequest::getInt('oerp_id');
		}
		return $this->oerp_id;
	}

	/**
	 * Get the docs to sign
	 * @return string The docs in an array
	 */
	private function getDocs($arrayList, $partnerVat) 
	{
		$docs = array();
		
		// request the selected id
		$oerp_id = $this->getOerp_id();
		
		// Get a TableOpenerp instance
		$table = $this->getTable();
		
		// Load the connection data
		$table->load($oerp_id);
		
		// ... define $HOST, $PORT, $DB, $USER, $PASS
		$HOST = $table->host;
		$PORT = $table->port;
		$DB = $table->db;
		$USER = $table->user;
		$PASS = $table->password;

		set_include_path(JPATH_COMPONENT."/libraries");
		include("get_openerp_uid.inc");

		// Search documents
		$client = new xmlrpc_client("http://$HOST:$PORT/xmlrpc/object");
		$msg = new xmlrpcmsg('execute');
		$msg->addParam(new xmlrpcval($DB, "string"));
		$msg->addParam(new xmlrpcval($uid, "int"));
		$msg->addParam(new xmlrpcval($PASS, "string"));
		$msg->addParam(new xmlrpcval("ir.attachment", "string"));
		$msg->addParam(new xmlrpcval("search", "string"));
		$msg->addParam(new xmlrpcval($arrayList, "array"));
		$resp = $client->send($msg);
		$ids = $resp->value();
		
		$msg = new xmlrpcmsg('execute');
		$msg->addParam(new xmlrpcval($DB, "string"));
		$msg->addParam(new xmlrpcval($uid, "int"));
		$msg->addParam(new xmlrpcval($PASS, "string"));
		$msg->addParam(new xmlrpcval("ir.attachment", "string"));
		$msg->addParam(new xmlrpcval("read", "string"));
		$msg->addParam($ids);
		$msg->addParam(php_xmlrpc_encode(array('document_type_id',
								'name','contact_ids','file_size','doc_state',
								'datas_fname','checked','note_to_partner')));
		$resp = $client->send($msg);
		
		$docs = php_xmlrpc_decode($resp->value());
			
		$contacts = array();
		foreach ($docs as $doc) {
			foreach ($doc['contact_ids'] as $rpc) {
				$contacts[$rpc] = '';
			}
		}
		$msg = new xmlrpcmsg('execute');
		$msg->addParam(new xmlrpcval($DB, "string"));
		$msg->addParam(new xmlrpcval($uid, "int"));
		$msg->addParam(new xmlrpcval($PASS, "string"));
		$msg->addParam(new xmlrpcval("res.partner.contact", "string"));
		$msg->addParam(new xmlrpcval("name_get", "string"));
		$msg->addParam(php_xmlrpc_encode(array_keys($contacts)));
		$resp = $client->send($msg);
		foreach (php_xmlrpc_decode($resp->value()) as $contact) {
			$contacts[$contact[0]] = $contact[1];
		}
		for ($j=0;$j<count($docs);$j++) {
			$doc = $docs[$j];
			for ($i=0;$i<count($doc['contact_ids']);$i++) {
				$docs[$j]['contact_ids'][$i] = array(
							$doc['contact_ids'][$i],
							$contacts[$doc['contact_ids'][$i]]
												);
			}
		}
		return $docs;
	}

	/**
	 * Get the docs to sign
	 * @return string The docs in an array
	 */
	public function getDocsToSign($id = 1) 
	{
		if (!is_array($this->docs_to_sign)) {
			$this->docs_to_sign = array();
		}
		
		if (!isset($this->docs_to_sign[$id])) 
		{
			
			$user =& JFactory::getUser();
			$partnerVat = $user->username;

			set_include_path(JPATH_COMPONENT."/libraries");
			include_once("phpxmlrpc/xmlrpc.inc");

			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('signer', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($partnerVat, "string") ,
				), "array"),
				new xmlrpcval('|', "string"),
					new xmlrpcval(array(
						new xmlrpcval('sign', "string"),
						new xmlrpcval('=', "string"),
						new xmlrpcval(false, "boolean") ,
					), "array"),
					new xmlrpcval(array(
						new xmlrpcval('sign', "string"),
						new xmlrpcval('=', "string"),
						new xmlrpcval('', "string") ,
					), "array"),
			);
			$this->docs_to_sign = $this->getDocs($arrayList, $partnerVat);
		}
		return $this->docs_to_sign;
	}

	/**
	 * Get the docs owned by the user
	 * @return string The docs in an array
	 */
	public function getOwnDocs($id = 1) 
	{
		if (!is_array($this->own_docs)) {
			$this->own_docs = array();
		}
		
		if (!isset($this->own_docs[$id])) 
		{
			$user =& JFactory::getUser();
			$partnerVat = $user->username;

			set_include_path(JPATH_COMPONENT."/libraries");
			include_once("phpxmlrpc/xmlrpc.inc");

			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('partner_id.vat', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval('ES'.$partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('doc_state', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval('checked', "boolean") ,
				), "array"),
			);
			$this->own_docs = $this->getDocs($arrayList, $partnerVat);
		}
		return $this->own_docs;
	}
	
	/**
	 * Get the docs signed and verified by the user
	 * @return string The docs in an array
	 */
	public function getCheckedDocs($id = 1) 
	{
		if (!is_array($this->checked_docs)) {
			$this->checked_docs = array();
		}
		
		if (!isset($this->checked_docs[$id])) 
		{
			$user =& JFactory::getUser();
			$partnerVat = $user->username;

			set_include_path(JPATH_COMPONENT."/libraries");
			include_once("phpxmlrpc/xmlrpc.inc");

			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('signer', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('doc_state', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval('checked', "boolean") ,
				), "array"),
			);
			$this->checked_docs = $this->getDocs($arrayList, $partnerVat);
		}
		return $this->checked_docs;
	}

	/**
	 * Get the docs signed and verified by the user
	 * @return string The docs in an array
	 */
	public function getUnverifiedDocs($id = 1) 
	{
		if (!is_array($this->unverified_docs)) {
			$this->unverified_docs = array();
		}
		
		if (!isset($this->unverified_docs[$id])) 
		{
			$user =& JFactory::getUser();
			$partnerVat = $user->username;

			set_include_path(JPATH_COMPONENT."/libraries");
			include_once("phpxmlrpc/xmlrpc.inc");

			$arrayList = array(
				new xmlrpcval(array(
					new xmlrpcval('signer', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval($partnerVat, "string") ,
				), "array"),
				new xmlrpcval(array(
					new xmlrpcval('doc_state', "string"),
					new xmlrpcval('=', "string"),
					new xmlrpcval('unchecked', "boolean") ,
				), "array"),
			);
			$this->unverified_docs = $this->getDocs($arrayList, $partnerVat);
		}
		return $this->unverified_docs;
	}
}
