# -*- coding: utf-8 -*-
##############################################################################
#
#    Pere Ramon Erro Mas
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools.translate import _

    
class mysql_ssl_server_wizard(osv.osv_memory):
    _name = 'mysql.ssl_server.wizard'
    
    _columns = {
        'myconn_id' : fields.many2one('membership.joomla_site', string='Mysql Connection',),
        'mysql_server_privkey' : fields.many2one('crypto.pairkey', string='Mysql Server Private Key',),
        'mysql_server_cert' : fields.many2one('crypto.certificate', string='Mysql Server Certificate',),
        'shell_script' : fields.text('Shell script'),  
    }
    
    _defaults = {
        'myconn_id' : lambda self,cr,uid,context={}: context.get('active_ids', [False,])[0],
    }
    
    def mysql_subject(self, subject):
        # Transformation needed (?)
        return '/'+'/'.join(subject.split(', '))
    
    def action_cancel(self, cr, uid, ids, context=None):
        return {}
    
    def fill_shell_script(self, cr, uid, ids, context=None):
        for wiz in self.browse(cr, uid, ids, context=context):
            vals = {'dbname': wiz.myconn_id.mysql_dbname,
                   'mysql-user': wiz.myconn_id.mysql_user,
                   'cacert': wiz.myconn_id.mysql_ca_cert.crt,
                   'server-cert': wiz.mysql_server_cert.crt,
                   'server-key' : wiz.mysql_server_privkey.key,
                   'client-crt-subject' : self.mysql_subject(wiz.myconn_id.mysql_client_cert.crt_subject),}            
            script = """
#!/bin/sh
MYSQL_CONF_DIR="/etc/mysql" 
SSL_CERTS_DIR="/etc/ssl/certs"
MYSQL_CNF="$MYSQL_CONF_DIR/my.cnf"

echo "%(cacert)s" > $MYSQL_CONF_DIR/cacert.pem

ln -s /etc/mysql/cacert.pem $SSL_CERTS_DIR/`openssl x509 -hash -noout -in $MYSQL_CONF_DIR/cacert.pem`.0

echo "%(server-cert)s" > $MYSQL_CONF_DIR/server-cert.pem
echo "%(server-key)s" > $MYSQL_CONF_DIR/server-key.pem
            """ % vals 
            script += """
perl -e "

%modifica = (
    'ssl-key' => 'server-key.pem',
    'ssl-ca' => 'cacert.pem',
    'ssl-cert' => 'server-cert.pem',
);
\$seccio = 'mysqld';

my \$seccio_trobada=0;

open(ARXIU,\$ENV{MYSQL_CNF});
while (<ARXIU>) {
    if (/\[.*\]/) {
    if (\$seccio_trobada) {
        foreach \$k (keys %modifica) {
        \$value = \$ENV{MYSQL_CONF_DIR}.'/'.\$modifica{\$k};
        print \"\$k=\$value\\n\";
        }
    }
    \$seccio_trobada=0;
    }
    if (/\[\$seccio\]/) {
    \$seccio_trobada=1;
    }
    \$trobat = 0;
    if (\$seccio_trobada) {
    foreach \$k (keys %modifica) {
        \$trobat |= /^\$k\s*=/;
    }
    }
    if (! \$trobat) {
    print;
    }
}
close ARXIU;
" > /tmp/dummy.cnf

cp $MYSQL_CNF $MYSQL_CNF.old
cp /tmp/dummy.cnf $MYSQL_CNF

            """
            script += """
mysql --execute="
    GRANT ALL PRIVILEGES
        ON %(dbname)s.* -- all hosts
        TO '%(mysql-user)s'@'%%'
        IDENTIFIED BY '' -- without password
        REQUIRE SUBJECT '%(client-crt-subject)s'
        ;" mysql
mysql --execute="
    GRANT ALL PRIVILEGES
        ON %(dbname)s.* -- all hosts
        TO '%(mysql-user)s'@'localhost'
        IDENTIFIED BY '' -- without password
        REQUIRE SUBJECT '%(client-crt-subject)s'
        ;" mysql
            """ % vals
            self.write(cr, uid, [wiz.id], {'shell_script': script,})
        return True
                    
mysql_ssl_server_wizard()
                                   
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: