<?php
/**
* @package		Viafirma Joomla Client
* @copyright	Copyright (C) 2010 Viafirma.
* Cliente para Joomla de Viafirma.
* Permite la autenticacin mediante certificado difital y DNIe utilizando Viafirma.
*/

set_include_path(get_include_path() . PATH_SEPARATOR . JPATH_ROOT.'/plugins/authentication/viafirma');
require_once "Auth/OpenID/Consumer.php";
require_once "Auth/OpenID/FileStore.php";
require_once "Auth/OpenID/AX.php";
defined('_JEXEC') or die;

/**
 * Viafirma Authentication Plugin
 *
 */

class plgAuthenticationViafirma extends JPlugin
{
	/**
	 * OpenId Atributes.
	 */
	private static $attribute;
	
	private static $proxyHost;
	private static $proxyPort;
	private static $proxyUser;
	private static $proxyPassword;
	private static $appId;
	private static $appPassword;
	

	private static $URL_SERRVICE_VIAFIRMA;//

	public static function getTheToken($forceNew = false)
	   {
	      $session = JFactory::getSession();

	      return $session->getFormToken();
	   }

	/**
	 * @param 	object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 */
	function plgAuthenticationViafirma(& $subject, $config)
	{
		parent::__construct($subject, $config);
		
		
		 plgAuthenticationViafirma::$appId=$this->params->get('userKey', '');
		 plgAuthenticationViafirma::$appPassword = $this->params->get('apiKey', '');
		 plgAuthenticationViafirma::$URL_SERRVICE_VIAFIRMA=$this->params->get('url_viafirma', '');;
		 //plgAuthenticationViafirma::$URL_SERRVICE_VIAFIRMA="http://services.viafirma.com/viafirma/pip/joomla";
		
		define('Auth_OpenID_RAND_SOURCE', null);
		jimport('openid.consumer');
		jimport('openid.Auth.OpenID.AX');
		//Basci Attributes
		plgAuthenticationViafirma::$attribute = array();
		
		//Numero de identificacion fiscal del usurio o similar
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://www.viavansi.com/schema/person/numberId', 1, true, 'numberUserId');
		//Nombre de la autoridad de certificacionn.
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://www.viavansi.com/schema/certificate/caName', 1, true, 'caName');
		//Conjunto de oids recuperados del certificado
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://www.viavansi.com/schema/certificate/oid', 1, true, 'oids');
		//Tipo de certificado, ej: FNMT, Camerfirma, etc.
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://www.viavansi.com/schema/certificate/type', 1, true, 'typeCertificate');
		//Tipo de certificado, ej: Persona fisica, Persona juridica, etc.
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://www.viavansi.com/schema/certificate/legal', 1, true, 'typeLegal');
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://schema.openid.net/contact/email', 1, true, 'email');
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://openid.net/schema/namePerson/first', 1, true, 'firstName');
		plgAuthenticationViafirma::$attribute[] = Auth_OpenID_AX_AttrInfo::make('http://openid.net/schema/namePerson/last', 1, true, 'lastName');
	}

	/**
	 * Login user with name of user. 
	 */
	private static function loginUserName($name,&$response)
	{
		// Query to DB to find username
		$db =& JFactory::getDBO();
		$query = 'SELECT `username`'
		    . ' FROM #__users'
		    . ' WHERE username=' . $db->Quote($name) ;
		$db->setQuery( $query );
		$username = $db->loadResult();
		
		if($username){
			$response->username=$username;
            $response->status = JAuthentication::STATUS_SUCCESS;
            $response->error_message = "";
			return true;
		}else{
			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = "No se encuentra el usuario ". $name;
			return true;
		}
		
	}

	/**
	 * Basado en el codigo openid.php original de Joomla.
	 * This method should handle any authentication and report back to the subject
	 *
	 * @access	public
	 * @param   	array 	$credentials 	Array holding the user credentials
	 * @param 	array   $options     	Array of extra options
	 * @param	object	$response	Authentication response object
	 * @return	object	boolean
	 * @since 1.5
	 */
	function onUserAuthenticate( $credentials, $options, &$response )
	{
		
	
		$mainframe =& JFactory::getApplication();
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
			define('Auth_OpenID_RAND_SOURCE', null);
		} else {
			$f = @fopen('/dev/urandom', 'r');
			if ($f !== false) {
				define('Auth_OpenID_RAND_SOURCE', '/dev/urandom');
				fclose($f);
			} else {
				$f = @fopen('/dev/random', 'r');
				if ($f !== false) {
					define('Auth_OpenID_RAND_SOURCE', '/dev/urandom');
					fclose($f);
				} else {
					define('Auth_OpenID_RAND_SOURCE', null);
				}
			}
		}
		jimport('openid.consumer');
		jimport('joomla.filesystem.folder');

		// Access the session data
		$session = & JFactory :: getSession();

		// Create and/or start using the data store
		$store_path = JPATH_ROOT . '/tmp/_joomla_openid_store';
		if (!JFolder :: exists($store_path) && !JFolder :: create($store_path)) {
			$response->type = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = "Could not create the FileStore directory '$store_path'. " . " Please check the effective permissions.";
			return false;
		}

		// Create store object
		$store = new Auth_OpenID_FileStore($store_path);

		// Create a consumer object
		$consumer = new Auth_OpenID_Consumer($store);

		if (!isset ($_SESSION['_openid_consumer_last_token'])) {
			// Begin the OpenID authentication process.
			if (!$auth_request = $consumer->begin(plgAuthenticationViafirma::$URL_SERRVICE_VIAFIRMA)) {
				$response->type = JAUTHENTICATE_STATUS_FAILURE;
				$response->error_message = 'Authentication error : could not connect to the openid server';
				return false;
			}

			// Create AX fetch request Viafirma
			$ax = new Auth_OpenID_AX_FetchRequest();

			// Anadimos todos los atributos de Viafirma
			foreach(plgAuthenticationViafirma::$attribute as $attr){
				$ax->add($attr);
			}

			// Add AX fetch request to authentication request
			$auth_request->addExtension($ax);
			
			
			//Create the entry url
			$entry_url = isset ($options['entry_url']) ? $options['entry_url'] : JURI :: base();
			$entry_url = JURI :: getInstance($entry_url);
			
			//$entry_url= JURI::getInstance($URL_SERVICE_VIAFIRMA);
			
			
			unset ($options['entry_url']); //We don't need this anymore

			//Create the url query information
			$options['return'] = isset($options['return']) ? base64_encode($options['return']) : base64_encode(JURI::base());
			$options[plgAuthenticationViafirma::getTheToken()] = 1;
			
			$process_url  = sprintf(JURI::base() . "index.php/component/users?task=user.login&username=%s", $credentials['username']);
			$process_url .= '&'.JURI::buildQuery($options);

			$session->set('return_url', $process_url );

			$trust_url = $entry_url->toString(array (
				'path',
				'host',
				'port',
				'scheme'
			));
			$session->set('trust_url', $trust_url);
			
			// Register API KEY
			$this->checkApiKey($auth_request,$entry_url);
			
			
			// For OpenID 1, send a redirect.  For OpenID 2, use a Javascript
			// form to send a POST request to the server.
			if ($auth_request->shouldSendRedirect()) {
				$redirect_url = $auth_request->redirectURL($trust_url, $process_url);

				// If the redirect URL can't be built, display an error
				// message.
				if (Auth_OpenID :: isFailure($redirect_url)) {
					displayError("Could not redirect to server: " . $redirect_url->message);
				} else {
					// Send redirect.
					$mainframe->redirect($redirect_url);
					return false;
				}
			} else {
				// Generate form markup and render it.
				$form_id = 'openid_message';
				$form_html = $auth_request->htmlMarkup($trust_url, $process_url, false, array (
					'id' => $form_id
				));
				// Display an error if the form markup couldn't be generated;
				// otherwise, render the HTML.
				if (Auth_OpenID :: isFailure($form_html)) {
					error_log("El form_html ha fallat");
					//displayError("Could not redirect to server: " . $form_html->message);
				} else {
					JResponse :: setBody($form_html);
					echo JResponse :: toString($mainframe->getCfg('gzip'));
					$mainframe->close();
					return false;
				}
			}
		}
		$result = $consumer->complete($session->get('return_url'));
		switch ($result->status) {
			case Auth_OpenID_SUCCESS :
				{
					//Viafirma
					$ax = new Auth_OpenID_AX_FetchResponse();
					$obj = $ax->fromSuccessResponse($result);
					$numberUserId = $obj->data['http://www.viavansi.com/schema/person/numberId'][0];
					plgAuthenticationViafirma::loginUserName($numberUserId,$response);	
				}
				break;

			case Auth_OpenID_CANCEL :
				{
					$response->status = JAUTHENTICATE_STATUS_CANCEL;
					$response->error_message = 'Authentication cancelled';
				}
				break;

			case Auth_OpenID_FAILURE :
				{
					$response->status = JAUTHENTICATE_STATUS_FAILURE;
					$response->error_message = 'Authentication failed';
				}
				break;
		}
	}
	
	/**
	 * Comprueba el usuario y pass.
	 */
	private function checkApiKey($auth, $urlPeticion){
		if(isset(plgAuthenticationViafirma::$appId) && isset(plgAuthenticationViafirma::$appPassword) && plgAuthenticationViafirma::$appId !== null && plgAuthenticationViafirma::$appPassword !== null){
			$handler = $auth->assoc->handle;

				//No tenemos el handler correcto, enviamos la solicitud a viafirma para un nuevo handler...
				$urlPeticionHandler =  plgAuthenticationViafirma::$URL_SERRVICE_VIAFIRMA."?";
				$urlPeticionHandler .= "V1_REGISTER_CLIENT=true";
				$urlPeticionHandler .= "&openid.assoc_handle=".urlencode($handler);
				$urlPeticionHandler .= "&VIAFIRMA_CLIENT_APP_ID=".urlencode(plgAuthenticationViafirma::$appId);
				$urlPeticionHandler .= "&VIAFIRMA_CLIENT_APP_PASS=".urlencode(plgAuthenticationViafirma::$appPassword);

				$ch = curl_init();
				if($proxyHost != "" && $proxyPort != ""){
					curl_setopt($ch, CURLOPT_PROXY, $proxyHost);
					curl_setopt($ch, CURLOPT_PROXYPORT, $proxyPort);
					if($proxyUser != ""){
						curl_setopt($ch,CURLOPT_PROXYUSERPWD,"$proxyUser:$proxyPassword");
					}
				}
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_URL, $urlPeticionHandler);
				curl_exec($ch);
				$headers = curl_getinfo($ch);
				curl_close($ch);

				if($headers["http_code"] == "401"){
					die("Invalid Viafirma API KEY");
					return false;
				}else{
					//$asociaciones[$urlPeticion] = $handler;
					//$this->putMapAssociattions($asociaciones);
				}

		}
		return true;
	}
	
	
}
